c7bec357dee5240bf778c84f3d304982b4648c40
[platform/upstream/coreutils.git] / tests / misc / help-version
1 #! /bin/sh
2 # Make sure all these programs work properly
3 # when invoked with --help or --version.
4
5 # Copyright (C) 2000-2008 Free Software Foundation, Inc.
6
7 # This program is free software: you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation, either version 3 of the License, or
10 # (at your option) any later version.
11
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 # GNU General Public License for more details.
16
17 # You should have received a copy of the GNU General Public License
18 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
19
20 test "$VERBOSE" = yes && set -x
21
22 # Ensure that $SHELL is set to *some* value and exported.
23 # This is required for dircolors, which would fail e.g., when
24 # invoked via debuild (which removes SHELL from the environment).
25 test "x$SHELL" = x && SHELL=/bin/sh
26 export SHELL
27
28 . $srcdir/test-lib.sh
29
30 expected_failure_status_nohup=127
31 expected_failure_status_timeout=125
32 expected_failure_status_printenv=2
33 expected_failure_status_tty=3
34 expected_failure_status_sort=2
35 expected_failure_status_expr=3
36 expected_failure_status_lbracket=2
37 expected_failure_status_dir=2
38 expected_failure_status_ls=2
39 expected_failure_status_vdir=2
40
41 fail=0
42
43 test "$built_programs" \
44   || { echo "$this_test: no programs built!?!" 1>&2; Exit $fail; }
45
46 for lang in C fr da; do
47   for i in $built_programs; do
48
49     # Skip `test'; it doesn't accept --help or --version.
50     test $i = test && continue;
51
52     # false fails even when invoked with --help or --version.
53     if test $i = false; then
54       env LC_MESSAGES=$lang $i" --help >/dev/null && fail=1
55       env LC_MESSAGES=$lang $i" --version >/dev/null && fail=1
56       continue
57     fi
58
59     # The just-built install executable is always named `ginstall'.
60     test $i = install && i=ginstall
61
62     # Make sure they exit successfully, under normal conditions.
63     env $i --help    > h-$i     || fail=1
64     env $i --version >/dev/null || fail=1
65
66     # Make sure they mention the bug-reporting address in --help output.
67     grep "$PACKAGE_BUGREPORT" h-$i > /dev/null || fail=1
68     rm -f h-$i
69
70     # Make sure they fail upon `disk full' error.
71     if test -w /dev/full && test -c /dev/full; then
72       env $i --help    >/dev/full 2>/dev/null && fail=1
73       env $i --version >/dev/full 2>/dev/null && fail=1
74       status=$?
75       test $i = [ && prog=lbracket || prog=$i
76       eval "expected=\$expected_failure_status_$prog"
77       test x$expected = x && expected=1
78       if test $status = $expected; then
79         : # ok
80       else
81         fail=1
82         echo "*** $i: bad exit status \`$status' (expected $expected)," 1>&2
83         echo "  with --help or --version output redirected to /dev/full" 1>&2
84       fi
85     fi
86   done
87 done
88
89 tmp=tmp-$$
90 tmp_in=in-$$
91 tmp_in2=in2-$$
92 tmp_dir=dir-$$
93 tmp_out=out-$$
94 mkdir $tmp || fail=1
95 cd $tmp || fail=1
96
97 comm_args="$tmp_in $tmp_in"
98 csplit_args="$tmp_in //"
99 cut_args='-f 1'
100 join_args="$tmp_in $tmp_in"
101 tr_args='a a'
102
103 chmod_args="a+x $tmp_in"
104 # Punt on these.
105 chgrp_args=--version
106 chown_args=--version
107 mkfifo_args=--version
108 mknod_args=--version
109 # Punt on uptime, since it fails (e.g., failing to get boot time)
110 # on some systems, and we shouldn't let that stop `make check'.
111 uptime_args=--version
112
113 # Create a file in the current directory, not in $TMPDIR.
114 mktemp_args=mktemp.XXXX
115
116 cmp_args="$tmp_in $tmp_in2"
117
118 # Tell dd not to print the line with transfer rate and total.
119 # The transfer rate would vary between runs.
120 dd_args=status=noxfer
121
122 diff_args="$tmp_in $tmp_in2"
123 sdiff_args="$tmp_in $tmp_in2"
124 diff3_args="$tmp_in $tmp_in2 $tmp_in2"
125 cp_args="$tmp_in $tmp_in2"
126 ln_args="$tmp_in ln-target"
127 ginstall_args="$tmp_in $tmp_in2"
128 mv_args="$tmp_in $tmp_in2"
129 mkdir_args=$tmp_dir/subdir
130 rmdir_args=$tmp_dir
131 rm_args=$tmp_in
132 shred_args=$tmp_in
133 touch_args=$tmp_in2
134 truncate_args="--reference=$tmp_in $tmp_in2"
135
136 basename_args=$tmp_in
137 dirname_args=$tmp_in
138 expr_args=foo
139
140 # Punt, in case GNU `id' hasn't been installed yet.
141 groups_args=--version
142
143 pathchk_args=$tmp_in
144 yes_args=--version
145 logname_args=--version
146 nohup_args=--version
147 printf_args=foo
148 seq_args=10
149 sleep_args=0
150 su_args=--version
151 timeout_args=--version
152
153 # I'd rather not run sync, since it spins up disks that I've
154 # deliberately caused to spin down (but not unmounted).
155 sync_args=--version
156
157 test_args=foo
158
159 # This is necessary in the unusual event that there is
160 # no valid entry in /etc/mtab.
161 df_args=/
162
163 # This is necessary in the unusual event that getpwuid (getuid ()) fails.
164 id_args=-u
165
166 # Use env to avoid invoking built-in sleep of Solaris 11's /bin/sh.
167 env sleep 10m &
168 kill_args=$!
169
170 link_args="$tmp_in link-target"
171 unlink_args=$tmp_in
172
173 ln -s . slink
174 readlink_args=slink
175
176 stat_args=$tmp_in
177 unlink_args=$tmp_in
178 lbracket_args=": ]"
179
180 # Ensure that each program "works" (exits successfully) when doing
181 # something more than --help or --version.
182 for i in $built_programs; do
183   # Skip these.
184   case $i in chroot|stty|tty|false|chcon|runcon) continue;; esac
185
186   rm -rf $tmp_in $tmp_in2 $tmp_dir $tmp_out
187   echo > $tmp_in
188   echo > $tmp_in2
189   mkdir $tmp_dir
190   # echo ================== $i
191   test $i = [ && prog=lbracket || prog=$i
192   eval "args=\$${prog}_args"
193   if env $i $args < $tmp_in > $tmp_out; then
194     : # ok
195   else
196     echo FAIL: $i
197     fail=1
198   fi
199   rm -rf $tmp_in $tmp_in2 $tmp_out $tmp_dir
200 done
201
202 Exit $fail